"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const push_1 = __importDefault(require("./push"));
const bump_1 = __importDefault(require("../scripts/bump"));
const telemetry_1 = __importDefault(require("../telemetry"));
const name = 'bump';
const signature = `${name} <version>`;
const description = 'bump your project to a new <version>';
const register = program => program
    .command(signature, undefined, { noHelp: true })
    .usage('<version> [options]')
    .description(description)
    .withPushOptions()
    .action(action);
async function action(version, options) {
    await telemetry_1.default.report('bump', { version }, options.interactive);
    await bump_1.default({ version });
    await push_1.default.runActionIfRequested(Object.assign({}, options));
}
exports.default = { name, signature, description, register, action };
//# sourceMappingURL=bump.js.map