"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const check_1 = __importDefault(require("../scripts/check"));
const Compiler_1 = require("../models/compiler/Compiler");
const ConfigManager_1 = __importDefault(require("../models/config/ConfigManager"));
const telemetry_1 = __importDefault(require("../telemetry"));
const name = 'check';
const signature = `${name} [contract]`;
const description = 'checks your contracts for potential issues';
const register = program => program
    .command(signature, undefined, { noHelp: true })
    .usage('[contract] [options]')
    .description(description)
    .option('--skip-compile', 'skips contract compilation')
    .action(action);
async function action(contractName, options) {
    ConfigManager_1.default.initStaticConfiguration();
    if (!options.skipCompile)
        await Compiler_1.compile();
    await telemetry_1.default.report('check', { contractName }, options.interactive);
    check_1.default({ contractName });
}
exports.default = { name, signature, description, register, action };
//# sourceMappingURL=check.js.map