"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const remove_1 = __importDefault(require("../scripts/remove"));
const push_1 = __importDefault(require("./push"));
const prompt_1 = require("../prompts/prompt");
const telemetry_1 = __importDefault(require("../telemetry"));
const name = 'remove';
const signature = `${name} [contracts...]`;
const description = 'removes one or more contracts from your project. Provide a list of whitespace-separated contract names.';
const register = program => program
    .command(signature, undefined, { noHelp: true })
    .alias('rm')
    .usage('[contract1 ... contractN] [options]')
    .description(description)
    .withPushOptions()
    .withNonInteractiveOption()
    .action(action);
async function action(contracts, options) {
    const { interactive } = options;
    const args = { contracts };
    const props = getCommandProps();
    const prompted = await prompt_1.promptIfNeeded({ args, props }, interactive);
    await telemetry_1.default.report('remove', prompted, interactive);
    remove_1.default(prompted);
    await push_1.default.runActionIfRequested(Object.assign({}, options));
}
function getCommandProps() {
    return prompt_1.contractsList('contracts', 'Choose one or more contracts', 'checkbox', 'added');
}
exports.default = { name, signature, description, register, action };
//# sourceMappingURL=remove.js.map