"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const unpack_1 = __importDefault(require("../scripts/unpack"));
const telemetry_1 = __importDefault(require("../telemetry"));
const name = 'unpack';
const signature = `${name} [kit]`;
const description = `download and install an OpenZeppelin Starter Kit to the current directory`;
const register = program => program
    .command(signature, undefined, { noHelp: true })
    .usage('[kit]')
    .description(description)
    .withNonInteractiveOption()
    .action(action);
async function action(kit, options) {
    await telemetry_1.default.report('unpack', { repoOrName: kit }, options.interactive);
    await unpack_1.default({ repoOrName: kit });
}
exports.default = { name, signature, description, register, action };
//# sourceMappingURL=unpack.js.map