"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const NetworkController_1 = __importDefault(require("../models/network/NetworkController"));
/**
 * Initializes a zOS application testing and deploying it to the test network,
 * along with dependencies (if specified)
 * @param txParams optional txParams (from, gas, gasPrice) to use on every transaction
 * @param networkFile optional `NetworkFile` object to use, instead of zos.test.json
 */
async function default_1(txParams = {}, networkFile) {
    const controller = new NetworkController_1.default('test', txParams, networkFile);
    await controller.deployDependencies();
    await controller.push(networkFile.projectFile.contracts, { reupload: false, force: true });
    return controller.project;
}
exports.default = default_1;
//# sourceMappingURL=TestHelper.js.map