export interface SessionOptions {
    network?: string;
    from?: string;
    timeout?: number;
    blockTimeout?: number;
    expires?: Date;
}
declare const Session: {
    getOptions(overrides?: SessionOptions, silent?: boolean): SessionOptions;
    setDefaultNetworkIfNeeded(network: string): void;
    getNetwork(): {
        network: string | undefined;
        expired: boolean;
    };
    open({ network, from, timeout, blockTimeout }: SessionOptions, expires?: number, logInfo?: boolean): void;
    close(): void;
    ignoreFile(): void;
    _parseSession(): SessionOptions | undefined;
    _setDefaults(session: SessionOptions): SessionOptions;
    _hasExpired(session: SessionOptions): boolean;
};
export default Session;
//# sourceMappingURL=Session.d.ts.map