"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasToMigrateProject = void 0;
const readline_1 = __importDefault(require("readline"));
const ManifestVersion_1 = require("../models/files/ManifestVersion");
const NetworkFile_1 = __importDefault(require("../models/files/NetworkFile"));
async function hasToMigrateProject(network) {
    const version = NetworkFile_1.default.getManifestVersion(network);
    if (ManifestVersion_1.isMigratableManifestVersion(version)) {
        const response = await new Promise(resolve => {
            const prompt = readline_1.default.createInterface({
                input: process.stdin,
                output: process.stdout,
            });
            prompt.question(`An old @openzeppelin/cli version was detected and needs to be migrated to the latest one.\nDo you want to proceed? [y/n] `, answer => {
                prompt.close();
                resolve(answer);
            });
        });
        if (!isValidResponse(response))
            return hasToMigrateProject(network);
        return response === 'y' || response === 'Y';
    }
    return true;
}
exports.hasToMigrateProject = hasToMigrateProject;
function isValidResponse(response) {
    return response === 'y' || response === 'Y' || response === 'n' || response === 'N';
}
//# sourceMappingURL=migrations.js.map