"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const upgrades_1 = require("@newos/upgrades");
async function accounts({ network }) {
    const defaultAccount = await upgrades_1.ZWeb3.defaultAccount();
    const accounts = await upgrades_1.ZWeb3.eth.getAccounts();
    if (accounts && accounts.length !== 0) {
        upgrades_1.Loggy.noSpin(__filename, `accounts`, `network-name`, `Accounts for ${network}:`);
        upgrades_1.Loggy.noSpin(__filename, `accounts`, `default-account`, `Default: ${defaultAccount}`);
        upgrades_1.Loggy.noSpin(__filename, `accounts`, `all-accounts`, `All:\n${accounts.map((account, index) => `- ${index}: ${account}`).join('\n')}`);
    }
    else {
        upgrades_1.Loggy.noSpin(__filename, `accounts`, `accounts-msg`, `There are no accounts for ${network}`);
    }
}
exports.default = accounts;
//# sourceMappingURL=accounts.js.map