"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const LocalController_1 = __importDefault(require("../models/local/LocalController"));
const ProjectFile_1 = __importDefault(require("../models/files/ProjectFile"));
async function init({ name, version, publish = false, dependencies = [], installDependencies = false, force = false, projectFile = new ProjectFile_1.default(), typechainEnabled = false, typechainOutdir = null, typechainTarget = null, }) {
    const controller = new LocalController_1.default(projectFile, true);
    controller.init(name, version, force, publish);
    const typechain = { enabled: typechainEnabled };
    if (typechainEnabled)
        Object.assign(typechain, { outDir: typechainOutdir, target: typechainTarget });
    controller.projectFile.setCompilerOptions({ typechain });
    if (dependencies.length !== 0)
        await controller.linkDependencies(dependencies, installDependencies);
    controller.writePackage();
}
exports.default = init;
//# sourceMappingURL=init.js.map