"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const stdout_1 = __importDefault(require("../utils/stdout"));
const NetworkController_1 = __importDefault(require("../models/network/NetworkController"));
const upgrades_1 = require("@newos/upgrades");
const input_1 = require("../utils/input");
async function queryDeployment({ salt, sender, network, txParams = {}, networkFile, }) {
    input_1.validateSalt(salt, true);
    const controller = new NetworkController_1.default(network, txParams, networkFile);
    try {
        const address = await controller.getProxyDeploymentAddress(salt, sender);
        const senderLog = sender ? ` from ${sender} ` : ' ';
        upgrades_1.Loggy.noSpin(__filename, 'queryDeployment', 'query-deployment', `Any contract created with salt ${salt}${senderLog}will be deployed to the following address`);
        stdout_1.default(address);
        return address;
    }
    finally {
        controller.writeNetworkPackageIfNeeded();
    }
}
exports.default = queryDeployment;
//# sourceMappingURL=query-deployment.js.map