"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const stdout_1 = __importDefault(require("../utils/stdout"));
const NetworkController_1 = __importDefault(require("../models/network/NetworkController"));
const upgrades_1 = require("@newos/upgrades");
const input_1 = require("../utils/input");
async function querySignedDeployment({ packageName, contractName, methodName, methodArgs, network, txParams = {}, salt = null, signature = null, admin = null, networkFile, }) {
    input_1.validateSalt(salt, true);
    const controller = new NetworkController_1.default(network, txParams, networkFile);
    try {
        const { signer, address } = await controller.getProxySignedDeployment(salt, signature, packageName, contractName, methodName, methodArgs, admin);
        upgrades_1.Loggy.noSpin(__filename, 'querySignedDeployment', `query-signed-deployment`, `Contract created with salt ${salt} signed by ${signer} will be deployed to the following address`);
        stdout_1.default(address);
        return address;
    }
    finally {
        controller.writeNetworkPackageIfNeeded();
    }
}
exports.default = querySignedDeployment;
//# sourceMappingURL=query-signed-deployment.js.map