"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const NetworkController_1 = __importDefault(require("../models/network/NetworkController"));
async function setAdmin({ newAdmin, packageName, contractName, proxyAddress, network, txParams = {}, networkFile, }) {
    if (!contractName && !proxyAddress && packageName) {
        throw Error('The address or name of the contract to transfer upgradeability admin rights must be provided.');
    }
    if (!newAdmin) {
        throw Error('The address of the new admin must be provided.');
    }
    const controller = new NetworkController_1.default(network, txParams, networkFile);
    try {
        if (contractName || proxyAddress) {
            const proxies = await controller.setProxiesAdmin(packageName, contractName, proxyAddress, newAdmin);
        }
        else {
            await controller.setProxyAdminOwner(newAdmin);
        }
    }
    finally {
        controller.writeNetworkPackageIfNeeded();
    }
}
exports.default = setAdmin;
//# sourceMappingURL=set-admin.js.map