"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const NetworkController_1 = __importDefault(require("../models/network/NetworkController"));
async function update({ packageName, contractName, proxyAddress, methodName, methodArgs, all, network, force = false, txParams = {}, networkFile, }) {
    if (!packageName && !contractName && !proxyAddress && !all) {
        throw Error('The package name, contract name, or address to upgrade must be provided, or set the `all` flag to upgrade all contracts in the application.');
    }
    const controller = new NetworkController_1.default(network, txParams, networkFile);
    try {
        await controller.logErrorIfProjectDeploymentIsInvalid(!force);
        const proxies = await controller.upgradeProxies(packageName, contractName, proxyAddress, methodName, methodArgs);
    }
    finally {
        controller.writeNetworkPackageIfNeeded();
    }
}
exports.default = update;
//# sourceMappingURL=update.js.map