"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transpileAndSave = void 0;
const upgradeability_transpiler_1 = require("@newos/upgradeability-transpiler");
const upgrades_1 = require("@newos/upgrades");
const fs_extra_1 = __importDefault(require("fs-extra"));
async function transpileAndSave(contracts) {
    const artifacts = await Promise.all(upgrades_1.Contracts.listBuildArtifacts().map(p => fs_extra_1.default.readJson(p)));
    const output = upgradeability_transpiler_1.transpileContracts(contracts, artifacts, upgrades_1.Contracts.getLocalContractsDir());
    for (const file of output) {
        await fs_extra_1.default.outputFile(file.path, file.source);
    }
}
exports.transpileAndSave = transpileAndSave;
//# sourceMappingURL=transpiler.js.map